align 0x10
Start:
call denter
sub pesp,psize*8 ;create space on stack
mov pedi,pesp
MakeStack

call sysGetStdHandle

mov peax,cTitle
call sysSetConsoleTitle

mov pesi,Welcome
call WriteInConsole

xor eax,eax
CPUID

mov dword [vendorName1],ebx
mov dword [vendorName2],edx
mov dword [vendorName3],ecx

mov eax,1
CPUID
and ecx,0x80000000 ; check on hypervisor
jz noHyperVisor

;get hypervisor name
mov eax,0x40000000
CPUID

mov dword [visorName1],ebx
mov dword [visorName2],ecx
mov dword [visorName3],edx

noHyperVisor:
mov pesi,vendorName
call WriteInConsole

;get highest function possible
mov eax,0x80000000
CPUID
mov [highestExtendedFunction],eax

cmp eax,0x80000004
jl noBrandName

mov ecx,3
mov pesi,brandName1

loopBrandName:
  push pecx

  mov eax,0x80000005
  sub eax,ecx
  CPUID

  mov [pesi],eax
  mov [pesi+0x4],ebx
  mov [pesi+0x8],ecx
  mov [pesi+0xC],edx
  add pesi,0x10

  pop pecx
loop loopBrandName

noBrandName:
mov pesi,brandName
call WriteInConsole

mov pesi,newLine
call WriteInConsole

mov pesi,FeaturesStr
call WriteInConsole

mov eax,1
CPUID
mov ebx,edx ; EBX => Feature EDX

mov pesi,Features
call startLoopFeatures

mov pesi,Features2Str
call WriteInConsole

mov eax,1
CPUID
mov ebx,ecx ; EBX => Feature ECX
mov pesi,Features2
call startLoopFeatures

xor eax,eax
CPUID
cmp eax,7
jb goToExtendedFutures

mov pesi,Features3Str
call WriteInConsole

mov eax,7
xor ecx,ecx
CPUID ;EBX => Feature

mov pesi,Features3
call startLoopFeatures

mov pesi,Features4Str
call WriteInConsole

mov eax,7
xor ecx,ecx
CPUID
mov ebx,ecx ;EBX => Feature ECX

mov pesi,Features4
call startLoopFeatures

mov pesi,Features5Str
call WriteInConsole

mov eax,7
xor edx,edx
CPUID
mov ebx,edx ;EBX => Feature ECX

mov pesi,Features5
call startLoopFeatures

goToExtendedFutures:
cmp [highestExtendedFunction],0x80000001
jl noExtendedFeatures

mov pesi,Features6Str
call WriteInConsole

mov eax,0x80000001
xor edx,edx
CPUID
mov ebx,edx ;EBX => Feature ECX

mov pesi,Features6
call startLoopFeatures

mov pesi,Features7Str
call WriteInConsole

mov eax,0x80000001
xor ecx,ecx
CPUID
mov ebx,ecx ;EBX => Feature ECX

mov pesi,Features7
call startLoopFeatures

noExtendedFeatures:

endLoopFeatures:
call dleave

exit:
sysExit 0xFFFFFFFF
ret



printSpace:
call denter

call cpushSpace

  db ' ',0

cpushSpace:

pop pesi
call WriteInConsole

call dleave
ret


;-----`

startLoopFeatures:
mov dword [pedi+psize*3],32

loopFeatures:
;  mov pedx,optionStart
;  call WriteInConsoleEDX

  mov pedx,optionUnselected

  shr ebx,1
  jnc bitNotSet

    mov pedx,optionSelected

bitNotSet:
  cmp byte [pesi],0
  jz nextBit

  call WriteInConsoleEDX
  call WriteInConsole
  call WriteNewLine

nextBit:
  push pesi
  call strlen
  add pesi,peax
  inc pesi

  dec dword [pedi+psize*3]
jnz loopFeatures

ret


;------------
;Input: ESI
;Corupts: EAX, (ECX / R9)
WriteInConsole:
mov pedx,pesi
jmp WriteInConsoleEDX
ret

;------------

;Corupts: EAX, EDX, (ECX / R9)
WriteNewLine:
mov pedx,newline
mov eax,1
call sysWriteConsole
ret

;------------
;Input: EDX
;Corupts: EAX, (ECX / R9)
WriteInConsoleEDX:

push pedx
call strlen

call sysWriteConsole

;if used is32
;  lea ecx,dword [pedi+psize*2]
;else
;  sub rsp,psize*6
;  lea r9,qword [pedi+psize*2]
;end if
;
;argpush 5,0
;if used is32
;  push ecx
;end if
;argpush 3,peax
;argpush 2,pedx
;argpush 1,pdword [pedi+psize]
;call [WriteFile]
;
;if used is64
;  add rsp,psize*6
;end if

NothingToWriteEDX:
ret

strlen:
  call denter

  xor ecx,ecx  ; zero ECX
  dec pecx     ; (R/E)CX => -1  (scasb will be repeated for 0xFFFFFFFF(FFFFFFFF) times, or until zero byte is found)
  xor eax,eax  ; byte to find with scasb => '\0'
  mov pedi,pdword [pebp+(psize*2)] ;(R/E)DI => pointer to ASCII string
  mov pedx,pedi ; (R/E)DX => copy of pointer to ASCII string

  test pedi,pedi
jz endStrlen    ;jump if pointer is zero

  repnz scasb   ;loop string until zero byte is found

endStrlen:
  sub pedi,pedx ; current pos of zero byte - begin of string = size of string
  mov peax,pedi ;(R/E)AX => size of string
  dec peax

  call dleave
  ret (psize*1)



cTitle db 'CPUID view',0
Welcome db '-------------------------------',0Ah
        db '--Written by Tycho Veltmeijer--',0Ah
        db '----CPUID tool version 1.00----',0Ah
        db '-------------------------------',0Ah,0


newline db 0Ah

vendorName:
db 'Vendor ID: '
vendorName1 dd ?
vendorName2 dd ?
vendorName3 dd ?
db 0Ah ;end

hyperVName:
db 'Hypervisor: '
visorName1 dd 'None'
visorName2 dd 0x20202020
visorName3 dd 0x20202020
db 0

brandName:
db 0Ah,'BrandName: '
brandName1 dd 'None'
brandName2 dd 0x20202020
brandName3 dd 0x20202020
brandName4 dd 0x20202020

brandName5 dd 0x20202020
brandName6 dd 0x20202020
brandName7 dd 0x20202020
brandName8 dd 0x20202020

brandName9 dd 0x20202020
brandName10 dd 0x20202020
brandName11 dd 0x20202020
brandName12 dd 0x20202020

brandName13 dd 0x20202020
brandName14 dd 0x20202020
brandName15 dd 0x20202020
brandName16 dd 0x20202020

newLine db 0Ah,0Ah,0 ;end

;optionStart db '[',0
optionSelected db '[x] ',0
optionUnselected db '[ ] ',0

highestExtendedFunction dd ?

FeaturesStr db 'EAX=1, EDX=',0Ah,0

Features db 'Onboard x87 FPU',0,\
            'Virtual 8086 mode extensions (such as VIF, VIP, PIV)',0,\
            'Debugging extensions (CR4 bit 3)',0,\
            'Page Size Extension',0,\
            'Time Stamp Counter',0,\
            'Model-specific registers',0,\
            'Physical Address Extension',0,\
            'Machine Check Exception',0,\
            'CMPXCHG8 (compare-and-swap) instruction',0,\
            'Onboard Advanced Programmable Interrupt Controller',0,\
            0,\
            'SYSENTER and SYSEXIT instructions',0,\
            'Memory Type Range Registers',0,\
            'Page Global Enable bit in CR4',0,\
            'Machine check architecture',0,\
            'Conditional move and FCMOV instructions',0,\
            'Page Attribute Table',0,\
            '36-bit page size extension',0,\
            'Processor Serial Number',0,\
            'CLFLUSH instruction (SSE2)',0,\
            0,\
            'Debug store: save trace of executed jumps',0,\
            'Onboard thermal control MSRs for ACPI',0,\
            'MMX instructions',0,\
            'FXSAVE, FXRESTOR instructions, CR4 bit 9',0,\
            'SSE instructions (a.k.a. Katmai New Instructions)',0,\
            'SSE2 instructions',0,\
            'CPU cache supports self-snoop',0,\
            'Hyper-threading',0,\
            'Thermal monitor automatically limits temperature',0,\
            'IA64 processor emulating x86',0,\
            'Pending Break Enable (PBE# pin) wakeup support',0

Features2Str db 0Ah,'EAX=1, ECX=',0Ah,0

Features2 db 'Prescott New Instructions-SSE3 (PNI)',0,\
            'PCLMULQDQ support',0,\
            '64-bit debug store (edx bit 21)',0,\
            'MONITOR and MWAIT instructions (SSE3)',0,\
            'CPL qualified debug store',0,\
            'Virtual Machine eXtensions',0,\
            'Safer Mode Extensions (LaGrande)',0,\
            'Enhanced SpeedStep',0,\
            'Thermal Monitor 2',0,\
            'Supplemental SSE3 instructions',0,\
            'L1 Context ID',0,\
            'Silicon Debug interface',0,\
            'Fused multiply-add (FMA3)',0,\
            'CMPXCHG16B instruction',0,\
            'Can disable sending task priority messages',0,\
            'Perfmon & debug capability',0,\
            0,\
            'Process context identifiers (CR4 bit 17)',0,\
            'Direct cache access for DMA writes',0,\
            'SSE4.1 instructions',0,\
            'SSE4.2 instructions',0,\
            'x2APIC support',0,\
            'MOVBE instruction (big-endian)',0,\
            'POPCNT instruction',0,\
            'APIC supports one-shot operation using a TSC deadline value',0,\
            'AES instruction set',0,\
            'XSAVE, XRESTOR, XSETBV, XGETBV',0,\
            'XSAVE enabled by OS',0,\
            'Advanced Vector Extensions',0,\
            'F16C (half-precision) FP support',0,\
            'RDRAND (on-chip random number generator) support',0,\
            'Running on a hypervisor (always 0 on a real CPU, but also with some hypervisors)',0

Features3Str db 0Ah,'EAX=7, EBX=',0Ah,0

Features3 db 'Access to base of %fs and %gs',0,\
            'IA32_TSC_ADJUST',0,\
            'Software Guard Extensions',0,\
            'Bit Manipulation Instruction Set 1',0,\
            'Transactional Synchronization Extensions',0,\
            'Advanced Vector Extensions 2',0,\
            0,\
            'Supervisor-Mode Execution Prevention',0,\
            'Bit Manipulation Instruction Set 2',0,\
            'Enhanced REP MOVSB/STOSB',0,\
            'INVPCID instruction',0,\
            'Transactional Synchronization Extensions',0,\
            'Platform Quality of Service Monitoring',0,\
            'FPU CS and FPU DS deprecated',0,\
            'Intel MPX (Memory Protection Extensions)',0,\
            'Platform Quality of Service Enforcement',0,\
            'AVX-512 Foundation',0,\
            'AVX-512 Doubleword and Quadword Instructions',0,\
            'RDSEED instruction',0,\
            'Intel ADX (Multi-Precision Add-Carry Instruction',0,\
            'Supervisor Mode Access Prevention',0,\
            'AVX-512 Integer Fused Multiply-Add Instructions ',0,\
            'PCOMMIT instruction',0,\
            'CLFLUSHOPT instruction',0,\
            'CLWB instruction',0,\
            'Intel Processor Trace',0,\
            'AVX-512 Prefetch Instructions',0,\
            'AVX-512 Exponential and Reciprocal Instructions',0,\
            'AVX-512 Conflict Detection Instructions',0,\
            'Intel SHA extensions',0,\
            'AVX-512 Byte and Word Instructions',0,\
            'AVX-512 Vector Length Extensions',0

Features4Str db 0Ah,'EAX=7, ECX=',0Ah,0

Features4 db 'PREFETCHWT1 instruction',0,\
            'AVX-512 Vector Bit Manipulation Instructions',0,\
            'User-mode Instruction Prevention',0,\
            'Memory Protection Keys for User-mode pages',0,\
            'PKU enabled by OS',0,\
            0,\
            'AVX-512 Vector Bit Manipulation Instructions 2',0,\
            0,\
            'Galois Field instructions',0,\
            'Vector AES instruction set (VEX-256/EVEX)',0,\
            'CLMUL instruction set (VEX-256/EVEX)',0,\
            'AVX-512 Vector Neural Network Instructions',0,\
            'AVX-512 BITALG instructions',0,\
            0,\
            'AVX-512 Vector Population Count Double and Quad-word',0,\
            0,\
            0,\ ;de volgende 5 bits:'The value of userspace MPX Address-Width Adjust used by the BNDLDX and BNDSTX Intel MPX instructions in 64-bit mode',0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            'Read Processor ID ',0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            'SGX Launch Configuration',0,\
            0

Features5Str db 0Ah,'EAX=7, EDX=',0Ah,0

Features5 db 0,\
            0,\
            'AVX-512 4-register Neural Network Instructions',0,\
            'AVX-512 4-register Multiply Accumulation Single precision',0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            'Platform configuration (Memory Encryption Technologies Instructions) ',0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            'Speculation Control: Indirect Branch Restricted Speculation (IBRS) and Indirect Branch Prediction Barrier (IBPB)',0,\
            'Single Thread Indirect Branch Predictor (STIBP)',0,\
            0,\
            'IA32_ARCH_CAPABILITIES MSR',0,\
            0,\
            'Speculative Store Bypass Disable (SSBD),[21] as mitigation for Speculative Store Bypass',0

Features6Str db 0Ah,'EAX=0x80000001, EDX=',0Ah,0

Features6 db 0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            'SYSCALL and SYSRET instructions',0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            0,\
            'Multiprocessor Capable',0,\
            'NX bit',0,\
            0,\
            'Extended MMX',0,\
            0,\
            0,\
            'FXSAVE/FXRSTOR optimizations',0,\
            'Gibibyte pages',0,\
            'RDTSCP instruction',0,\
            0,\
            'Long mode',0,\
            'Extended 3DNow!',0,\
            '3DNow!',0

Features7Str db 0Ah,'EAX=0x80000001, ECX=',0Ah,0

Features7 db 'LAHF/SAHF in long mode',0,\
            'Hyperthreading not valid',0,\
            'Secure Virtual Machine',0,\
            'Extended APIC space',0,\
            'CR8 in 32-bit mode',0,\
            'Advanced bit manipulation (lzcnt and popcnt)',0,\
            'SSE4a',0,\
            'Misaligned SSE mode',0,\
            'PREFETCH and PREFETCHW instructions',0,\
            'OS Visible Workaround',0,\
            'Instruction Based Sampling',0,\
            'XOP instruction set',0,\
            'SKINIT/STGI instructions',0,\
            'Watchdog timer',0,\
            0,\
            'Light Weight Profiling',0,\
            '4 operands fused multiply-add',0,\
            'Translation Cache Extension',0,\
            0,\
            'NodeID MSR',0,\
            0,\
            'Trailing Bit Manipulation',0,\
            'Topology Extensions',0,\
            'Core performance counter extensions',0,\
            'NB performance counter extensions',0,\
            0,\
            'Data breakpoint extensions',0,\
            'Performance TSC',0,\
            'L2I perf counter extensions',0,\
            0,\
            0,\
            0

;------------

